import * from dw::Runtime
var jsonValue = {
  value: '{"name": "Mariano"}' as Binary {encoding: "UTF-8"},
  encoding: "UTF-8",
  properties: {},
  mimeType: "application/json"
}

var jsonValue2 = {
  value: '{"name": "Mariano", "lastName": "achaval"}' as Binary {encoding: "UTF-8"},
  encoding: "UTF-8",
  properties: {},
  mimeType: "application/json"
}

var invalidJsonValue = {
  value: '{"name": "Mariano' as Binary {encoding: "UTF-8"},
  encoding: "UTF-8",
  properties: {},
  mimeType: "application/json"
}

var Utils = "fun sum(a,b) = a + b"
var UtilsPath = prop("file.separator") default "" ++ "Utils.dwl"
---
{
  "execute_ok" : run("main.dwl", {"main.dwl": "{a: 1}"}, {"payload": jsonValue }),
  "accessRaw" : run("main.dwl", {"main.dwl": "payload.^raw"}, {"payload": jsonValue }),
  "logs" : do {
    var execResult = run("main.dwl", {"main.dwl": "{a: log(1)}"}, {"payload": jsonValue })
    ---
    {
        m: execResult.result.logs.message,
        l: execResult.result.logs.level
    }
  },
  "grant" : run("main.dwl", {"main.dwl": "{a: readUrl(`http://google.com`)}"}, {"payload": jsonValue }, {},{ securityManager: (grant, args) -> false })
                 then ((result) -> {
                         fail: result.success,
                         logs: result.error.logs
                       }),
  "library" : run("main.dwl", {"main.dwl": "Utils::sum(1,2)", "$UtilsPath": Utils }, {"payload": jsonValue }),
  "timeout" : run("main.dwl", {"main.dwl": "(1 to 1000000000000) map \$ + 1" }, {"payload": jsonValue }, {},{timeOut: 2}).success,
  "execFail" : do {
    var execResult = run("main.dwl", {"main.dwl": "dw::Runtime::fail('My Bad')" }, {"payload": jsonValue })
    ---
    {
      kind: execResult.error.kind,
      success: execResult.success,
      messageContainsFailFunction: execResult.error.message contains "fun fail (message: String = 'Error'): Nothing"
    }
  },
  "parseFail" : run("main.dwl", {"main.dwl": "(1 + " }, {"payload": jsonValue }),
  "writerFail" : run("main.dwl", {"main.dwl": "output application/xml --- 2" }, {"payload": jsonValue })
                        then ((result) -> {
                          fail: result.success,
                          logs: result.error.logs
                        }),
  "readerFail" : run("main.dwl", {"main.dwl": "output application/xml --- payload" }, {"payload": invalidJsonValue }),
  "defaultOutput" : run("main.dwl", {"main.dwl": "payload" }, {"payload": jsonValue2}, {},{outputMimeType: "application/csv", writerProperties: {"separator": "|"}}),
  "onExceptionFail": do  {
      dw::Runtime::try( () ->
          run("main.dwl", {"main.dwl": "dw::Runtime::fail('Failing Test')" }, {"payload": jsonValue2}, {},{onException: "FAIL"})
      ).success
    },
  "customLogger":
         run(
   "main.dwl",
            {"main.dwl": "log(1234)" },
    {"payload": jsonValue2},
     {},
    {
                   loggerService: {
                      initialize: () -> {token: "123"},
                      log: (level, msg, context) -> log("$(level) $(msg)", context)
                   }
                 }
            )
}