%dw 2.0

output :Test.number json

ns ns1 http://acme.com
type Test = { ns1#message: String, number: Number, numberOrString: String | Number }
type TestRepeated = { ns1#message*: String| Number, number: Number, numberOrString: String | Number }
type NestedObjectTest = { nestedObject: { message: String, number: Number} }
type UnionTypeBuildWithSelectors = Test.ns1#message {schemaKey: "schemaValue"} | Test.number {schemaKey: "schemaValue"} | { key: "value"}
type StringOrNumber = TestRepeated.ns1#message
type OneString = Test.ns1#message
type OneNumber = Test.number
type NumberOrString = Test.numberOrString
type Nombre = String { tato: "test"}
type TypeReferenceOnFunctions = { testFunctionWithTypeSelectorReference: (Test.number) -> Test.ns1#message }
type TestType = { anObjectWithStringField: { test: String} }

type FirstLvlSelection = {oneNumber: Test.number}
type NestedSelection = FirstLvlSelection.oneNumber
type WithParameters<A, B> = {first: A, second: B}
type CloseObj = {|first: String, second: Boolean|}
type OptionalKey = {first: String, second?: Boolean}
type AttributeKeyName = {first: String, second @(secondAttr: Boolean): Number}
type SelectionInUpperBound<A <: Test.number> = {first: A}
type SelectionInAttribute = {first: String, second @(secondAttr: Test.number): Number}
type SelectionInUnion = String | Test.number
type SelectionInIntersection = {} & NestedObjectTest.nestedObject

var number = "number"
var testingTypes: OneString = "adsfadsf"
var testingTypes2: OneNumber = 123
var testingTypes3: NumberOrString = "testing"
var testingTypes4: NumberOrString = 123
var testingTypes5: StringOrNumber = "testing"
var testingTypes6: StringOrNumber = 123
var testingTypes7: NestedObjectTest."nestedObject".message = testingTypes
var testingTypes10: NestedObjectTest.'nestedObject'.message = testingTypes
var testingTypes8: NestedObjectTest.nestedObject.number = testingTypes2
var usingTypeBuiltFromUnion: UnionTypeBuildWithSelectors = "message"
var functionTest: TypeReferenceOnFunctions.testFunctionWithTypeSelectorReference = (test: Number) -> test as String

var nestedSelectionVar: NestedSelection = 123
var withParametersVar: WithParameters<String, Boolean>.first = "Should be a String"
var withParametersVar2: WithParameters<Boolean, Number>.second = 453
var onCloseObjType: CloseObj.second = true
var optionalKeyVar: OptionalKey.second = true
var attributeKeyVar: AttributeKeyName.second = 123
// TODO FIX W-11501045
//var attributeKeyVar2: AttributeKeyName.second.@secondAttr = true
var selectionInTypeParamVar: WithParameters<String, Test.number>.second = 234
var selectionInUpperBoundVar: SelectionInUpperBound<123> = {first: 123}
var selectionInAttributeVar: SelectionInAttribute = {first: "", second @(secondAttr: 123): 43}
var selectionInUnionVar: SelectionInUnion = 123
var selectionInIntersectionVar: SelectionInIntersection = {message: "", number: 123, extra: true}


fun functionWithSelectorsInTypes(testFunction: TypeReferenceOnFunctions.testFunctionWithTypeSelectorReference): TestType.anObjectWithStringField = {
  test: testFunction(123)
}
---
123
